VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2895
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   5625
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2895
   ScaleWidth      =   5625
   Begin VB.CommandButton cmdAssignment 
      Caption         =   "Assignment"
      Enabled         =   0   'False
      Height          =   495
      Left            =   1560
      TabIndex        =   8
      Top             =   1680
      Width           =   1215
   End
   Begin VB.CommandButton cmdMemCopy 
      Caption         =   "MemCopy"
      Enabled         =   0   'False
      Height          =   495
      Left            =   3000
      TabIndex        =   5
      Top             =   1680
      Width           =   1215
   End
   Begin VB.CommandButton cmdForLoop 
      Caption         =   "For Loop"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Caption         =   "Array Creation"
      Height          =   1335
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2655
      Begin VB.CommandButton cmdBuildArray 
         Caption         =   "Build Array"
         Height          =   495
         Left            =   720
         TabIndex        =   3
         Top             =   720
         Width           =   1215
      End
      Begin VB.TextBox SizeText 
         Height          =   285
         Left            =   1440
         TabIndex        =   2
         Text            =   "1.0"
         Top             =   240
         Width           =   495
      End
      Begin VB.Label Label1 
         Caption         =   "Array Size (MB)"
         Height          =   255
         Left            =   240
         TabIndex        =   1
         Top             =   240
         Width           =   1095
      End
   End
   Begin VB.Label TimeLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   960
      TabIndex        =   7
      Top             =   2280
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "Time (sec)"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   2280
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Declare the memory copying funciton.
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Array1() As Long
Private Array2() As Long
Private NumItems As Long
Private Bytes As Single

Private Sub cmdAssignment_Click()
Dim start_time As Single
Dim i As Long

    MousePointer = vbHourglass
    DoEvents
    
    start_time = Timer
    Array2 = Array1
    TimeLabel.Caption = _
        Format$(Timer - start_time, "0.00")
    MousePointer = vbDefault
End Sub


Private Sub cmdBuildArray_Click()
    MousePointer = vbHourglass
    TimeLabel.Caption = ""
    DoEvents
    
    Bytes = CSng(SizeText.Text) * 1024 * 1024
    NumItems = Bytes / Len(NumItems)
    ReDim Array1(1 To NumItems)
    ReDim Array2(1 To NumItems)

    cmdForLoop.Enabled = True
    cmdAssignment.Enabled = True
    cmdMemCopy.Enabled = True
    MousePointer = vbDefault
End Sub


Private Sub cmdForLoop_Click()
Dim start_time As Single
Dim i As Long

    MousePointer = vbHourglass
    DoEvents
    
    start_time = Timer
    For i = 1 To NumItems
        Array2(i) = Array1(i)
    Next i
    TimeLabel.Caption = _
        Format$(Timer - start_time, "0.00")
    MousePointer = vbDefault
End Sub

Private Sub cmdMemCopy_Click()
Dim start_time As Single

    MousePointer = vbHourglass
    DoEvents
    
    start_time = Timer
    CopyMemory Array2(1), Array1(1), Bytes
    TimeLabel.Caption = _
        Format$(Timer - start_time, "0.00")
    MousePointer = vbDefault
End Sub


Private Sub SizeText_Change()
    TimeLabel.Caption = ""
    cmdForLoop.Enabled = False
    cmdAssignment.Enabled = False
    cmdMemCopy.Enabled = False
End Sub


